//
//  AlertExtension.m
//  AlertExtension
//
//  Created by Yun Jinsang on 8/9/12.
//  Copyright (c) 2012 Yun Jinsang. All rights reserved.
//

#import "FlashRuntimeExtensions.h"
#import "AlertExtension.h"
#import <UIKit/UIKit.h>

@implementation AlertExtension

// 이 메소드를 플래시에서 호출할 것이다.
FREObject alert( FREContext context, void* data, uint32_t argc, FREObject param[] )
{
    NSLog( @"ALERT~~~" );
    
    NSString* message = nil;
    
    uint32_t titleLen;
    const uint8_t* titleString;
    NSString* title = nil;
    
    if( FRE_OK == FREGetObjectAsUTF8( param[ 0 ], &titleLen, &titleString ) )
        title = [NSString stringWithUTF8String:(char*) titleString];
    
    uint32_t messageLen;
    const uint8_t* messageString;
    
    if( FRE_OK == FREGetObjectAsUTF8( param[ 1 ], &messageLen, &messageString ) )
        message = [NSString stringWithUTF8String:(char*) messageString];
    
    UIAlertView* alert = [[UIAlertView alloc] initWithTitle:title message:message
                                                   delegate:[UIApplication sharedApplication] cancelButtonTitle:@"OK" otherButtonTitles:nil ];
    
    [alert show];
    
    return NULL;
}

void ContextInitializer( void* data, const uint8_t* type, FREContext context, uint32_t *functionNumber, const FRENamedFunction** functions )
{
    *functionNumber = 1;
    
    FRENamedFunction* function = (FRENamedFunction*) malloc( sizeof(functionNumber) );
    function[ 0 ].name = (const uint8_t *) "alert";
    function[ 0 ].functionData = NULL;
    function[ 0 ].function = &alert;
    
    *functions = function;
}

void ContextFinalizer( FREContext context )
{
    
}

// 초기화 생성자로 사용할 메소드
// ANE를 생성할 때 메소드명을 정확하게 지정해줘야 하므로 기록해두자.
void AlertExtensionInitializer( void** data, FREContextInitializer* initializer, FREContextFinalizer* finalizer )
{
    *data = NULL;
    *initializer = &ContextInitializer;
    *finalizer = &ContextFinalizer;
}

// 소멸자로 사용할 메소드
// 이 역시도 ANE를 생성할 때 메소드명을 정확하게 지정해줘야 하므로 기록해두자.
void AlertExtensionFinalizer( void* data )
{
    
}


@end
